/*
 * CenterOfMass.java
 * Copyright (C) 1998 ymnk, JCraft Inc.
 *
 * This file is part of JSpringies, a mass and spring simulation system for Java
 *
 * JSpringies is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * JSpringies is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XSpringies; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package com.jcraft.jspringies;

class CenterOfMass extends Force{
  double ogx, ogy;
  CenterOfMass(Space s, double v, double m){
    super(s, v, m);
  }
  void force(){
    ogx=0.0;
    ogy=0.0;
    double mixix = 0.0, mixiy = 0.0, mivix = 0.0, miviy = 0.0, msum = 0.0;
    Mass m;
    for(int i=0; i<sp.masses.length; i++){
      m = sp.masses[i];
      if (m != sp.center_mass && m.AliveNotFixedp()) {
	msum += m.mass;
	mixix += (m.mass * m.x);
	mixiy += (m.mass * m.y);
	mivix += (m.mass * m.vx);
	miviy += (m.mass * m.vy);
      }
    }
    if (msum>0.0) {
      mixix /= msum; mixiy /= msum;
      mivix /= msum; miviy /= msum;
      mixix -= sp.center_x; mixiy -= sp.center_y;
      ogx -= ((gval * mixix + gmisc * mivix) / msum);
      ogy -= ((gval * mixiy + gmisc * miviy) / msum);
    }
/*
    for(i=0; i<masses.length; i++){
      Mass m = masses[i];
      if (m.AliveNotFixedp()) {
	if (m.Id() != sp.center_id) {
	  m.ax += ogx;
	  m.ay += ogy;
	}
      }
    }
*/
  }
}
