/*
 * Force.java
 * Copyright (C) 1998 ymnk, JCraft Inc.
 *
 * This file is part of JSpringies, a mass and spring simulation system for Java
 *
 * JSpringies is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * JSpringies is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XSpringies; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package com.jcraft.jspringies;

abstract class Force{
  Space sp;
  double gval;
  double gmisc;
  boolean enable;
  Force(Space s, double v, double m){
    sp=s; gval=v; gmisc=m;
    enable=false;
  }
  void setVal(double v){gval=v;}
  void setMisc(double m){gmisc=m;}
  void setEnable(boolean b){enable=b;}
  double getVal(){ return gval;}
  double getMisc(){ return gmisc;}
  boolean getEnable(){ return enable;}

  abstract void force();
}
