/*
 * PointerAttraction.java
 * Copyright (C) 1998 ymnk, JCraft Inc.
 *
 * This file is part of JSpringies, a mass and spring simulation system for Java
 *
 * JSpringies is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * JSpringies is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XSpringies; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package com.jcraft.jspringies;

class PointerAttraction extends Force{
  PointerAttraction(Space s, double v, double m){
    super(s, v, m);
  }
  void force(){
    Mass m;
    double center_x=sp.center_x;
    double center_y=sp.center_y;
    double center_rad=sp.center_rad;
    double dx, dy, mag, fmag;
    double foo, bar;
    for(int i=0; i<sp.masses.length; i++){
      m = sp.masses[i];
      if (m.AliveNotFixedp()) {
	dx = (center_x - m.x); 
	dy = (center_y - m.y);
	mag = Math.sqrt(dx * dx + dy * dy);
	if (mag < m.radius + center_rad) {
	  foo=m.radius + center_rad;
	  bar=mag/foo;
	  dx *= bar; dy *= bar;
	  mag = foo;
	}
	fmag = (gval / Math.pow(mag, gmisc)) / mag;
	m.ax += fmag * dx;
	m.ay += fmag * dy;
      }
    }
  }
}
